module Figures where

import Control.Exception(assert)

data Figures = 
    Circle Double
  | Square Double
  | Rectangle Double Double
  | Triangle Double Double Double  -- Keine Invariante am Konstruktor
    deriving Show

-- Konstruktor mit Invariante
triangle :: Double-> Double-> Double-> Figure
triangle a b c = 
  assert (a <= b+c && b<= a+c && c<= a+c) $ Triangle a b c


perimeter :: Figure-> Double
perimeter (Circle r) = 2*pi*r
perimeter (Square a) = 4*a
perimeter (Triangle a b c)= a+ b+ c
