import math

class Circle:
  def __init__(self, r):
    self.r= r
  def perimeter(self):
    return 2*self.r*math.pi

class Square:
  def __init__(self, a):
    self.a= a
  def perimeter(self): 
    return 4*self.a

class Triangle: 
  def __init__(self, a, b, c):
    # We can assert an invariant
    assert a<= b+c and b<= a+c and c<= a+b, "Triangle inequation violated."
    self.sides= [a, b, c]
  def perimeter(self):
    return sum(self.sides)