trait Figure {
  def perimeter(): Double
}

import Math.PI

case class Circle(r: Double) extends Figure {
  def perimeter() = 2*r* PI
}

case class Square(a: Double) extends Figure {
  def perimeter() = 4* a
}

case class Triangle(a: Double, b: Double, c: Double) extends Figure {
  require(a<= b+c && b<= a+c && c<= a+b);
  def perimeter() = a+ b+ c
}